program gen09;

{$APPTYPE CONSOLE}

uses
  SysUtils,math;

const
    maxn = 100000;

var
  p,n,k,i,t,l:integer;
  a,b,c: array [1..maxn] of integer;
begin
  randseed := strtoint(paramstr(1));
  n := strtoint(paramstr(2));
  k := strtoint(paramstr(3));
  p := strtoint(paramstr(4));
  writeln(2*(n div 2),' ',2,' ',p);
  for i:=1 to n div 4 do
  begin
    l := random(99)+1;
    writeln('+ 1 ',l);
    a[i]:=1;
    b[i]:=l;
  end;
  for i:=n div 4 + 1 to n div 2 do
  begin
    l := random(99)+1;
    writeln('+ 2 ',l);
    a[i]:=2;
    b[i]:=l;
  end;
  for i:= n div 2 downto 1 do
  begin
    writeln('- ',a[i],' ',b[i]);
  end;
end.
